package hr.fer.tel.ruazosa.sensors;

import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.widget.TextView;
import android.app.Activity;
import android.content.Context;

public class GPSActivity extends Activity {

	private LocationListener gpsListener = new GPSListener();

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gps);

		String provider = Context.LOCATION_SERVICE;
		LocationManager locationManager = (LocationManager) getSystemService(provider);
		locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, gpsListener);
		
		Location location = locationManager.getLastKnownLocation(provider);
		
		updateWithNewLocation(location);
	}
	
	private void updateWithNewLocation(Location location) {
		if (location != null) {
			double lat = location.getLatitude();
			double lng = location.getLongitude();
			
			TextView latv = (TextView) findViewById(R.id.latitude_tv);
			TextView lotv = (TextView) findViewById(R.id.longitude_tv);
			
			latv.setText(R.string.latitude_text);    			
			lotv.setText(R.string.longitude_text);
			
			latv.append(Double.toString(lat));
			lotv.append(Double.toString(lng));
			}
	}
	
	@Override
	public void finish() {
		super.finish();
		
		//stop listening location changes
		String provider = Context.LOCATION_SERVICE;
		LocationManager locationManager = (LocationManager) getSystemService(provider);
		locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0, gpsListener);
		locationManager.removeUpdates(gpsListener);
	}

	private class GPSListener implements LocationListener {

		public void onLocationChanged(Location location) {
			updateWithNewLocation(location);
		}

		public void onProviderDisabled(String provider) {
			// TODO Auto-generated method stub

		}

		public void onProviderEnabled(String provider) {
			// TODO Auto-generated method stub

		}

		public void onStatusChanged(String provider, int status, Bundle extras) {
			// TODO Auto-generated method stub

		}
	}
}
