package hr.fer.tel.ruazosa.sensors;

import org.openintents.sensorsimulator.hardware.Sensor;
import org.openintents.sensorsimulator.hardware.SensorEvent;
import org.openintents.sensorsimulator.hardware.SensorEventListener;
import org.openintents.sensorsimulator.hardware.SensorManagerSimulator;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.os.StrictMode;
import android.widget.TextView;
import android.app.Activity;
import android.content.Context;

public class AccelerometerActivity extends Activity {
	
	private SensorEventListener accelerometerListener = new AccelerometerListener();

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_accelerometer);

        String service_name = Context.SENSOR_SERVICE;
		SensorManagerSimulator sensorManager = SensorManagerSimulator.getSystemService(this, service_name);
		sensorManager.connectSimulator();
		
		Sensor accelerometer = sensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
		sensorManager.registerListener(accelerometerListener, accelerometer, SensorManagerSimulator.SENSOR_DELAY_NORMAL);
    }
    
    @Override
	public void finish() {
		super.finish();
		
		//stop listening location changes
		String service_name = Context.SENSOR_SERVICE;
		SensorManagerSimulator sensorManager = SensorManagerSimulator.getSystemService(this, service_name);
		sensorManager.connectSimulator();
		sensorManager.unregisterListener(accelerometerListener);
	}
    
    private void updateWithNewReading(SensorEvent event) {
    	if (event.type == Sensor.TYPE_ACCELEROMETER) {
			float xAxis_lateralA = event.values[0];
			float yAxis_longitudinalA = event.values[1];
			float zAxis_verticalA = event.values[2];
			
			TextView xtv = (TextView) findViewById(R.id.xAxis_lateralA);
			TextView ytv = (TextView) findViewById(R.id.yAxis_longitudinalA);
			TextView ztv = (TextView) findViewById(R.id.zAxis_verticalA);
			
			xtv.setText(R.string.xAxis_lateralA);    			
			ytv.setText(R.string.yAxis_longitudinalA);
			ztv.setText(R.string.zAxis_verticalA);
			
			xtv.append(Float.toString(xAxis_lateralA));
			ytv.append(Float.toString(yAxis_longitudinalA));
			ztv.append(Float.toString(zAxis_verticalA));
		}
    }



	private class AccelerometerListener implements SensorEventListener {

    	public void onAccuracyChanged(Sensor sensor, int accuracy) {
    		// TODO Auto-generated method stub	
    	}

    	public void onSensorChanged(SensorEvent event) {
    		AccelerometerActivity.this.updateWithNewReading(event);
    	}
    }
}
