package hr.fer.tel.ruazosa.sensors;

import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

import org.openintents.sensorsimulator.hardware.Sensor;
import org.openintents.sensorsimulator.hardware.SensorNames;
import org.openintents.sensorsimulator.hardware.SensorManagerSimulator;

public class ListSensorsActivity extends Activity {

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_list_sensors);

        //dirty hack to avoid NetworkOnMainThreadException
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

		Button button = (Button) findViewById(R.id.button_list_sensors);
		button.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				String service_name = Context.SENSOR_SERVICE;
				SensorManagerSimulator sensorManager = SensorManagerSimulator
						.getSystemService(ListSensorsActivity.this,
								service_name);
				sensorManager.connectSimulator();
				List<Integer> allSensors = sensorManager.getSensors();

				LinearLayout layout = (LinearLayout) findViewById(R.id.linear_layout_list);
				layout.removeAllViews();
				int counter = 0;
				for (int sensorType : allSensors) {
					TextView textView = new TextView(ListSensorsActivity.this);
					textView.setText(++counter + ". "
							+ SensorNames.getSensorName(sensorType));
					layout.addView(textView);

					// catch click on accelerometer
					if (sensorType == Sensor.TYPE_ACCELEROMETER) {
						textView.setOnClickListener(new View.OnClickListener() {
							public void onClick(View v) {
								Intent intent = new Intent(
										ListSensorsActivity.this,
										AccelerometerActivity.class);
								startActivity(intent);
							}
						});
					}
				}
			}
		});

        //same code as above, but for real sensors
//		Button buttonBroadcastIntent = (Button) findViewById(R.id.button_list_sensors);
//		buttonBroadcastIntent.setOnClickListener(new View.OnClickListener() {
//			public void onClick(View v) {
//				String service_name = Context.SENSOR_SERVICE;
//				SensorManager sensorManager = (SensorManager) getSystemService(service_name);
//				List<Sensor> allSensors = sensorManager
//						.getSensorList(Sensor.TYPE_ALL);
//
//				LinearLayout layout = (LinearLayout) findViewById(R.id.linear_layout_list);
//				for (int i = 0; i < allSensors.size(); i++) {
//					Sensor sensor = allSensors.get(i);
//					TextView textView = new TextView(ListSensorsActivity.this);
//					textView.setText(i + 1 + ". " + sensor.getName());
//					layout.addView(textView);
//				}
//			}
//		});
	}
}
